export declare function setProxy(params: any): void;
export declare function enable(): void;
export declare function getComputedStyleForNode(params: any): {
    computedStyle: ICSSProperty[];
};
export declare function getInlineStylesForNode(params: any): {
    inlineStyle: any;
};
export declare function getMatchedStylesForNode(params: any): {
    inlineStyle: any;
    matchedCSSRules: {
        matchingSelectors: number[];
        rule: any;
    }[];
};
export declare function getBackgroundColors(params: any): {
    backgroundColors: any[];
    computedFontSize: any;
    computedFontWeight: any;
};
export declare function getStyleSheetText(params: any): Promise<{
    text: string;
}>;
export declare function setStyleTexts(params: any): {
    styles: any[];
};
interface ICSSProperty {
    name: string;
    value: string;
    disabled?: boolean;
    implicit?: boolean;
    parsedOk?: boolean;
    text?: string;
}
export {};
