export declare function createId(): string;
export declare function getAbsoluteUrl(url: string): string;
export declare class ErrorWithCode extends Error {
    code: number;
    constructor(code: number, message: string);
}
export declare function createErr(code: number, message: string): ErrorWithCode;
export declare function getUrl(): string;
export declare function getOrigin(): string;
export declare function getTextContent(url: string, proxy?: string): Promise<any>;
export declare function getBase64Content(url: string, proxy?: string): Promise<any>;
