import types from 'licia/types';
declare type OnMessage = (message: string) => void;
declare type DomainMethod = (...args: any[]) => any;
export default class Chobitsu {
    private onMessage;
    private resolves;
    private domains;
    constructor();
    domain(name: string): {
        [index: string]: DomainMethod;
    } | undefined;
    setOnMessage(onMessage: OnMessage): void;
    sendMessage(method: string, params?: any): Promise<unknown>;
    sendRawMessage(message: string): Promise<void>;
    register(name: string, methods: types.PlainObj<types.AnyFn>): void;
    private callMethod;
}
export {};
