export declare function setProxy(params: any): void;
export declare function enable(): void;
export declare function reload(): void;
export declare function navigate(params: any): void;
export declare function getNavigationHistory(): {
    currentIndex: number;
    entries: {
        id: number;
        url: string;
        userTypedURL: string;
        title: string;
        transitionType: string;
    }[];
};
export declare function getAppManifest(): Promise<any>;
export declare function getResourceTree(): {
    frameTree: {
        frame: {
            id: string;
            mimeType: string;
            securityOrigin: string;
            url: string;
        };
        resources: {
            url: string;
            mimeType: string;
            type: string;
        }[];
    };
};
export declare function getResourceContent(params: any): Promise<{
    base64Encoded: boolean;
    content: string;
} | {
    content: string;
    base64Encoded?: undefined;
} | undefined>;
export declare function screencastFrameAck(): void;
export declare function startScreencast(): void;
export declare function stopScreencast(): void;
