import Emitter from 'licia/Emitter';
export declare class XhrRequest extends Emitter {
    private xhr;
    private method;
    private url;
    private id;
    private reqHeaders;
    constructor(xhr: XMLHttpRequest, method: string, url: string);
    toJSON(): {
        method: string;
        url: string;
        id: string;
    };
    handleSend(data: any): void;
    handleReqHeadersSet(key: string, val: string): void;
    handleHeadersReceived(): void;
    handleDone(): void;
}
export declare class FetchRequest extends Emitter {
    private url;
    private id;
    private method;
    private options;
    private reqHeaders;
    constructor(url: any, options?: any);
    send(fetchResult: any): void;
}
export declare function fullUrl(href: string): string;
